﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;
using System.Globalization;
using System.Reflection;
using PropertyGridDemo.Objects;
using PropertyGridDemo.Properties;

namespace PropertyGridDemo
{
    public partial class Form1 : Form
    {
        private DemoObject _object = new DemoObject();

        public Form1()
        {
            Thread.CurrentThread.CurrentCulture = new CultureInfo("en");
            Resources.Culture = Thread.CurrentThread.CurrentCulture;
            InitializeComponent();
            pgControl.SelectedObject = _object;
        }

        private void pgControl_PropertyValueChanged(object s, PropertyValueChangedEventArgs e)
        {
            if (e.ChangedItem.PropertyDescriptor.Name == "ShapeTypeProperty")
            {
                Shape shape = e.ChangedItem.Value as Shape;
                if (shape != null)
                {
                    _object.ShapeProperty = (Shape)shape.GetType().GetConstructor(Type.EmptyTypes).Invoke(null);
                }
            }
        }
    }
}
