﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms.Design;
using System.Drawing;
using System.Drawing.Design;
using System.ComponentModel;
using System.Windows.Forms;
using PropertyGridDemo.Objects;

namespace PropertyGridDemo.Controls
{
    public class ShapeEditor : UITypeEditor
    {
        public ShapeEditor()
        {
        }
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            Shape shape = value as Shape;
            if (shape != null)
            {
                ShapeDialogBox dlg = new ShapeDialogBox();
                dlg.SelectedObject = shape;
                dlg.ShowDialog();
                return shape;
            }
            return value;
        }
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }
    }
}
